export declare abstract class DataSource<T> {
    abstract getRows(): Promise<T[]>;
    abstract getRow(key: string): Promise<T>;
}
export default DataSource;
export interface IEditable<T> {
    add(newData: T): void;
    update(rowId: string, newData: T): void;
    delete(rowId: string): void;
}
