"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require("react");
// import './dropdown.scss';
var Dropdown = (function (_super) {
    __extends(Dropdown, _super);
    function Dropdown(props) {
        var _this = _super.call(this) || this;
        _this.state = {
            selected: props.selected,
            open: false
        };
        _this.toggle = _this.toggle.bind(_this);
        _this.onChange = _this.onChange.bind(_this);
        document.getElementsByTagName('body')[0].addEventListener('click', _this.closeHandler);
        return _this;
    }
    Dropdown.prototype.componentWillUnmount = function () {
        document.getElementsByTagName('body')[0].removeEventListener('click', this.closeHandler);
    };
    Dropdown.prototype.closeHandler = function (ev) {
        if (this.state && this.state.open) {
            this.setState({
                open: false
            });
        }
    };
    Dropdown.prototype.render = function () {
        var _this = this;
        var tOptions = this.props.options.map(function (option) {
            var tValue = option.formatValue ? option.formatValue(option) : option.value;
            return React.createElement("div", { className: option.className, key: option.key, onClick: _this.onChange.bind(_this, option.key), dangerouslySetInnerHTML: { __html: tValue } });
        });
        var tValue = '';
        if (this.state.selected && this.props.options.find(function (option) {
            return option.key === _this.state.selected.key;
        })) {
            tValue = this.state.selected.value;
        }
        else {
            tValue = 'Bitte auswählen';
            this.setState({
                selected: null
            });
        }
        var tOpen = this.state.open ? 'open' : '';
        return (React.createElement("div", { className: 'dropdown ' + tOpen },
            this.props.label ?
                React.createElement("label", null, this.props.label) : '',
            React.createElement("div", { className: 'value', onClick: this.toggle },
                tValue,
                React.createElement("i", { className: 'fa fa-angle-down' })),
            React.createElement("div", { className: 'drop' }, tOptions)));
    };
    Dropdown.prototype.toggle = function () {
        this.setState({
            open: !this.state.open
        });
    };
    Dropdown.prototype.onChange = function (key) {
        var tElement = this.props.options.find(function (option) {
            return option.key === key;
        });
        if (this.props.onChange) {
            if (this.props.name) {
                this.props.onChange(this.props.name, tElement);
            }
            else {
                this.props.onChange(tElement);
            }
        }
        this.setState({
            selected: tElement,
            open: false
        });
    };
    return Dropdown;
}(React.Component));
exports.Dropdown = Dropdown;
//# sourceMappingURL=index.js.map