var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import * as React from 'react';
import Row from './row';
import { combineClasses } from '../lib/util';
import { Icon } from '../';
export default (props) => {
    const tHeaderColumns = Object.getOwnPropertyNames(props.data).reduce((val, column) => {
        const tConfig = props.data[column];
        val[column] = tConfig.header || column;
        return val;
    }, {});
    const tHeaderClasses = [
        'header',
        props.className
    ];
    const tData = {};
    for (let index in props.data) {
        tData[index] = __assign({}, props.data[index]);
        tData[index].getCell = () => {
            return React.createElement("span", null,
                tData[index].header || index,
                props.sortField === index ? React.createElement(Icon, { name: 'angle-up', className: props.sortDir }) : '');
        };
    }
    return React.createElement(Row, { onColumnClick: (rowKey, columnKey) => {
            if (props.onColumClick) {
                props.onColumClick(columnKey);
            }
        }, rowKey: 'header', data: tHeaderColumns, config: tData, className: combineClasses(tHeaderClasses), filteredColumnClasses: props.filteredClassName, columnClasses: props.columnClassName, sortField: props.sortField });
};
//# sourceMappingURL=header.js.map