import * as React from 'react';
import { combineClasses } from '../lib/util';
export default (props) => {
    const tRowClasses = [
        'row',
        props.className
    ];
    const tProps = Object.getOwnPropertyNames(props.config);
    const tColumns = tProps
        .filter(prop => {
        let tConfig = props.config[prop];
        if (tConfig && !tConfig.hidden) {
            return true;
        }
        return false;
    })
        .sort((a, b) => {
        const tAConfig = props.config[a];
        const tBConfig = props.config[b];
        return (tAConfig.order || 0) - (tBConfig.order || 0);
    })
        .map(prop => {
        let tConfig = props.config[prop];
        if (tConfig.hidden) {
            return '';
        }
        const tColumnClasses = [props.columnClasses];
        if (props.sortField === prop) {
            tColumnClasses.push(props.filteredColumnClasses);
        }
        return React.createElement(Column, { key: prop, config: tConfig, value: props.data[prop], className: combineClasses(tColumnClasses), rowKey: props.rowKey, columnKey: prop, onColumnClick: (columnKey) => {
                if (props.onColumnClick) {
                    props.onColumnClick(props.rowKey, columnKey);
                }
            } });
    });
    return React.createElement("div", { className: combineClasses(tRowClasses) }, tColumns);
};
;
export function Column(props) {
    const tColumnClasses = [
        'col',
        props.className,
        props.config.size ? `col-${props.config.size}` : null
    ];
    let tValue = props.config.getCell ? props.config.getCell(props.rowKey, props.value) : props.value;
    return React.createElement("div", { className: combineClasses(tColumnClasses), onClick: () => {
            if (props.onColumnClick) {
                props.onColumnClick(props.columnKey);
            }
        } }, tValue);
}
//# sourceMappingURL=row.js.map